package calculation;

import static util.utils.X;
import static util.utils.r;

import java.util.ArrayList;
public class Agent {
	public double[] strategy=new double[2];
	public double eta;

	public int TAG;
	public int x;
	public int y;
	public double benefit=0;
	public int[] counter=new int[2];
	public ArrayList<Agent> neighbors=new ArrayList<Agent>();
	public double[] n_cooperative=new double[2];
	Agent(int tag){
		this.strategy[0]=r.nextDouble();
		this.strategy[1]=r.nextDouble();
		this.TAG=tag;
		this.eta=2*r.nextDouble()-1;
	}
	Agent(int tag,int type){
		this.strategy[0]=type;
		this.strategy[1]=1-type;
		this.TAG=tag;
		this.eta=2*r.nextDouble()-1;
	}
	public void calBenefit(){
		n_cooperative[0]=0;
		n_cooperative[1]=0;
		for(Agent neighbor:this.neighbors){
			int same_or_not=(this.TAG==neighbor.TAG)?0:1;
			n_cooperative[0]+=neighbor.strategy[same_or_not];
			n_cooperative[1]+=this.strategy[same_or_not]*neighbor.strategy[same_or_not];
		}
		this.benefit=(1+X)*(n_cooperative[0])-X*(n_cooperative[1]);
	}
	public void resetData(){
		this.counter[0]=0;
		this.counter[1]=0;
	}
	public static void setNeighbors(Agent a,Agent b){
		int same_or_not=(a.TAG==b.TAG)?0:1;
		a.counter[same_or_not]++;
		b.counter[same_or_not]++;
		a.neighbors.add(b);
		b.neighbors.add(a);
	}
}
